from scipy import *
import numpy.random as rd
import scipy.sparse as sp
import matrixcomp as mf

def user_ratings(ui, mat, movie, n=10):
    vec = mat[ui, :].tocsr()

    ret = []
    idxs = map(lambda x: x[0], movie)
    for vi in vec.indices:
        try:
            mname = movie[idxs.index(vi)][1]
        except ValueError:
            mname = "<Not present>"
        ret.append([mat[ui, vi], mname])
    ret.sort(key=lambda x: -x[0])
    return ret[:n]

def user_predict(ui, prob, movie, n=10):
    (arr, L, R, lam) = prob

    rats = L[ui, :].dot(R.T)
    rank = argsort(-rats)

    ret = []
    idxs = map(lambda x: x[0], movie)
    for vi in rank[:n]:
        try:
            mname = movie[idxs.index(vi)][1]
        except ValueError:
            mname = "<Not present>"

        ret.append([rats[vi], mname])
    ret.sort(key=lambda x: -x[0])
    return ret

#
(oarr, mat) = mf.load_movielens("ml-1m/ratings.dat")
movie = map(lambda x: [int(x[0]) - 1] + x[1:], map(lambda x: x.split("::"), open("ml-1m/movies.dat").read().splitlines()))

rd.shuffle(oarr)
#Number of users
nu = oarr[:, 0].max() + 1
#Number of movies
nm = oarr[:, 1].max() + 1

#Split dataset
tridx = floor(0.6 * oarr.shape[0])
vaidx = floor(0.8 * oarr.shape[0])

trarr = oarr[:tridx, :]
vaarr = oarr[tridx:vaidx, :]
tearr = oarr[vaidx:, :]
#

k = 100; lam = 1e-2
prob = mf.initialize_computation(nu, nm, trarr, k, lam)
#This passes over the data about 30 times over (see the implementation).
mf.matrix_factorize(prob)

#Predict the mse
mse = mean((mf.predict_ratings(vaarr, prob) - vaarr[:, 2])**2)

#Top predictions
ui = 99
top_pre = user_predict(ui, prob, movie)
top_rks = user_ratings(ui, mat, movie)
